Page MenuHomePhabricator

Phabricator lacks a feature like Bugzilla's "vote"
Closed, DeclinedPublic

Description

Use Cases:

  1. As a user, I want to flag a bug to watch later, but I don't want to just subscribe because I subscribe to a lot of bugs.
    1. Implemented by Phabricator "flags". You can flag a bug or a change and even add a note to yourself (the flag and note are private, afaict) about why you flagged it. It then shows up at eg: http://fab.wmflabs.org/flag/
  2. As a user, I want to indicate that I really want this bug fixed because it affects me.
    1. Implemented by Phabricator "tokens"
  3. The missing use case?

Details

Reference
fl150

Event Timeline

flimport raised the priority of this task from to Low.
flimport set Reference to fl150.

qgil wrote on 2014-04-17 18:49:15 (UTC)

A description would be welcome. The good news is that you can edit the description. ;)

Nemo_bis wrote on 2014-04-18 07:22:23 (UTC)

How can this be low priority? It blocks migration.

aklapper wrote on 2014-04-18 08:09:47 (UTC)

I don't see this blocking migration.

Wondering if this could be implemented the same way as T68.

aklapper wrote on 2014-04-18 10:16:36 (UTC)

Also, users can award a token like "Like", "Love", "Dislike", "World Burns" to a task, see "Award Token" in the Actions List. Sounds like voting to me?

jdforrester wrote on 2014-04-19 02:29:16 (UTC)

Agreed, this looks like it's already working to me (and with the added bonus of not misleading users by calling it "voting" as if votes direct effort).

Nemo_bis wrote on 2014-04-19 05:34:10 (UTC)

Need to test if one can search by tokens and if awarding a token subscribes to the task.

aklapper wrote on 2014-06-09 12:38:56 (UTC)

In T150#14, @Nemo_bis wrote:

if awarding a token subscribes to the task.

Currently it does not. Discussed upstream in https://secure.phabricator.com/T4945 if you want to join.

aklapper wrote on 2014-06-09 14:58:49 (UTC)

In T150#14, @Nemo_bis wrote:

Need to test if one can search by tokens

<epriestley> andre__: there are some very basic tools in the "Tokens" application. We might expand those eventually, but don't have any specific near-term plans. For stuff you're interested in, Flags might be another approach (basically, they're personal bookmarks of objects).
<epriestley> Maybe see also https://secure.phabricator.com/T3611 (Ability to sort tasks by 'interest'), which is vaguely related.
<epriestley> (Roughly, we attempted to sort tasks by some "interest" metric measured in subscriptions/comments/tokens and didn't come up with anything useful.)

Nemo_bis wrote on 2014-06-15 10:39:24 (UTC)

<epriestley> (Roughly, we attempted to sort tasks by some "interest" metric measured in subscriptions/comments/tokens and didn't come up with anything useful.)

Sounds like a good reason so keep votes, which work for basic sorting. :)

aklapper wrote on 2014-06-15 12:35:55 (UTC)

Sounds like a good reason so keep votes, which work for basic sorting. :)

Not sure I understand correctly. How to "keep votes"? There is no such functionality in upstream, there are tokens instead, and I don't see upstream being interested in implementing votes.
You might want to discuss in https://secure.phabricator.com/T3611 ? :)

Again, to me this is nothing I'd block day 1 on.

aklapper wrote on 2014-06-15 12:38:45 (UTC)

...and I don't know what "which work for basic sorting" means here. Sorting tickets after how many votes they have, I guess?
I'm not aware of anybody actually using that functionality in Bugzilla to influence decisions. Having that function to give users the wrong belief that votes would influence anything does not convince me. See related older discussions on wikitech-l.

Nemo_bis wrote on 2014-06-18 20:15:05 (UTC)

There is no such functionality in upstream, there are tokens instead

Configuring tokens to work like bugzilla votes would be ok too.

Is there a way to make token senders receive notifications for a ticket? If not, one thing we'll certainly need is adding all voters to subscribers in the bugzilla->phabricator migration script, is there a task for this?

I'm not aware of anybody actually using that functionality in Bugzilla to influence decisions.

If you're asking specific components, I'm personally aware of Translate, Wikidata, LiquidThreads, core (volunteers), upgraders https://www.mediawiki.org/wiki/Manual:Upgrading#Why_upgrade.3F .

greg wrote on 2014-06-19 00:29:54 (UTC)

In T150#25, @Nemo_bis wrote:

There is no such functionality in upstream, there are tokens instead

Configuring tokens to work like bugzilla votes would be ok too.

If that's what we want. I don't see that as decided yet. "Feature parity in every possible way, including old features we no longer need/want" is not the goal.

I'd honestly like to survey a few users of the "vote" functionality to see how it's really used. If it's only "flag it for me to watch later, but not just subscribe because I subscribe to a lot of bugs" then Phabricator Flags are in fact a reasonable feature complete replacement.

If it's for "I really really want this to get fixed, so I'm going to vote on it!" then, well, that never really worked for the vast majority of projects on Bugzilla. There's a feature in Launchpad called "This affects me" which lets logged in users indicate that a bug affects them; a +1 of sorts. We could instead use the tokens for this use case (the more unfriendly looking tokens on a task, the more users want it fixed, probably :) ).

Is there a way to make token senders receive notifications for a ticket? If not, one thing we'll certainly need is adding all voters to subscribers in the bugzilla->phabricator migration script, is there a task for this?

That's reasonable, it'd be preserving the subscriber list through migration.

I'm not aware of anybody actually using that functionality in Bugzilla to influence decisions.

If you're asking specific components, I'm personally aware of Translate, Wikidata, LiquidThreads, core (volunteers), upgraders https://www.mediawiki.org/wiki/Manual:Upgrading#Why_upgrade.3F .

That Why Upgrade link is misleading as it really isn't useful. The one on the wikipage points to a search for all bugs ever that are fixed and have votes (a staggering and unhelpful 438 bugs).

Here's the list of bugs closed in the last year that have votes: https://bugzilla.wikimedia.org/buglist.cgi?chfield=bug_status&chfieldfrom=2013-06-18&chfieldto=Now&columnlist=bug_severity%2Cshort_desc%2Ccomponent%2Cvotes%2Clongdescs.count%2Cversion%2Ctarget_milestone&known_name=Most%20voted%20fixes&list_id=322954&product=MediaWiki&query_based_on=Most%20voted%20fixes&query_format=advanced&resolution=FIXED&votes=3&votes_type=greaterthaneq --- 27 bugs

Or, the last 6 months: https://bugzilla.wikimedia.org/buglist.cgi?chfield=bug_status&chfieldfrom=2014-01-18&chfieldto=Now&columnlist=bug_severity%2Cshort_desc%2Ccomponent%2Cvotes%2Clongdescs.count%2Cversion%2Ctarget_milestone&known_name=Most%20voted%20fixes&list_id=322954&product=MediaWiki&query_based_on=Most%20voted%20fixes&query_format=advanced&resolution=FIXED&votes=3&votes_type=greaterthaneq --- 10 bugs

As an aside: One of the benefits of switching tools is being opinionated and making a better overall experience for getting things done.

aklapper wrote on 2014-06-26 13:11:21 (UTC)

Greg: Thanks for gathering data, this is helpful.

In T150#25, @Nemo_bis wrote:

Configuring tokens to work like bugzilla votes would be ok too.

Is there a way to make token senders receive notifications for a ticket? If not, one thing we'll certainly need is adding all voters to subscribers in the bugzilla->phabricator migration script, is there a task for this?

For the records, whether you get CCed on a ticket in Bugzilla when adding a vote depends on the user's settings in https://bugzilla.wikimedia.org/userprefs.cgi?tab=email

I've added an item to T350 about documentation, saying "Make clear that adding a token does not subscribe you to a task, but that you should add yourself to the CC list instead" because I prefer to untangle these two things, seeing how different interpretations of "what is that Vote button in Bugzilla used for" have been already.

In T150#26, @greg wrote:

it'd be preserving the subscriber list through migration.

With regard to migrating, I've added a comment to T423.

Summary: From my point of view, there's nothing actionable left in this ticket. Phabricator offers Tokens (hence WORKSFORME), we should document that (T350), we should migrate CC list because of votes (T423), and if we wanted to use tokens for prioritization/popularity, we have T414. Anything I'm missing?

aklapper wrote on 2014-07-02 16:40:46 (UTC)

Alright.... for the records, @Rush (temporarily reassigning) will try to investigate whether we can convert (T423) votes by a Bugzilla account on a Bugzilla ticket to a "Thumbs up" token by a Phab account on a Maniphest task.

If that turns out to be way too complicated and not worth the hassle, we might end up dropping this data and instead just add a generic "This task had xy votes in Bugzilla" to the initial description.

Note that Phabricator does not support querying explicitly for tickets that you yourself have awarded a token to. We have no idea how many people use Bugzilla's Voting functionality as a "list of tickets they are personally interested in" instead of CC'ing on those tickets (and potentially dealing with the bugmail that would create).

This could be considered a regression; one I'd be willing to accept.

aklapper wrote on 2014-07-09 16:35:11 (UTC)

Queried the DB to help judging popularity and how much efforts to spend on migrating Bugzilla votes into Phab tokens:

19423 registered Bugzilla users.
3889 Bugzilla users have given more than 0 votes to bug reports.
732 Bugzilla users have given more than 4 votes to bug reports.
329 Bugzilla users have given more than 9 votes to bug reports.
111 Bugzilla users have given more than 24 votes to bug reports.
45 Bugzilla users have given more than 49 votes to bug reports.

aklapper wrote on 2014-07-18 18:35:05 (UTC)

To summarize: We will migrate votes to tokens, but we do not aim at providing Bugzilla's exact Voting functionality with its many different interpretations, which makes this request (called "Phab lacks a feature like Bugzilla's vote") a WONTFIX.

In T150#26, @greg wrote:
In T150#25, @Nemo_bis wrote:

Is there a way to make token senders receive notifications for a ticket? If not, one thing we'll certainly need is adding all voters to subscribers in the bugzilla->phabricator migration script, is there a task for this?

it'd be preserving the subscriber list through migration.

We decided against this in T423.

aklapper wrote on 2014-07-22 20:25:38 (UTC)

In T150#36, @Aklapper wrote:

To summarize: We will migrate votes to tokens

Uhm. For the records: We cannot export votes via Bugzilla's API.
http://www.bugzilla.org/docs/4.4/en/html/api/Bugzilla/WebService/Bug.html says "Searching by votes was removed in Bugzilla 4.0.", reference: https://bugzilla.mozilla.org/show_bug.cgi?id=577049

In theory we could get them out of the database instead, but question is how much extra effort that would be and if it's worth it. Chase stated that we can conceivably import votes later if we needed to, to not block Day 1.

importing issue status

flimport closed this task as Declined.Sep 12 2014, 1:27 AM
flimport added a subscriber: chasemp.
He7d3r added a subscriber: He7d3r.Oct 24 2014, 11:04 AM
Kozuch added a subscriber: Kozuch.Dec 10 2014, 6:38 PM
Kozuch removed a subscriber: Kozuch.Dec 15 2014, 10:14 AM
Kozuch added a subscriber: Kozuch.
Dalba added a subscriber: Dalba.Apr 29 2015, 7:38 AM

As predicted, the removal of an explicit vote feature doesn't make people stop voting, but merely encourages voting on (valid) bugs in a messier way: for instance with comments, or in random places.

Qgil added a comment.Nov 11 2015, 9:00 AM

https://meta.wikimedia.org/wiki/2015_Community_Wishlist_Survey is not a random place, but an official survey where community contributors are encouraged to add/endorse/vote proposals.

No intention to "make people stop voting", to the contrary: People are encouraged to vote in places (like the Community Wishlist Survey) where their vote will be heard, is equally weighted, and has a clear outcome defined by a single process.
Bugzilla never had any of that.

Dalba awarded a token.Jan 31 2016, 5:29 AM

KDE.org enabling a feature is relevant to us how?

How is Phab's token system not a appropriate replacement for Bugzilla's voting system?

KDE.org enabling a feature is relevant to us how?

Why wouldn't what the others do be interesting?

How is Phab's token system not a appropriate replacement for Bugzilla's voting system?

That's been discussed in depth, above and in related tasks. If you think it may still not be clear enough for the interested persons, I welcome your help summarising the discussion in the task description.

Qgil removed a subscriber: Qgil.Nov 25 2016, 8:31 AM
Aklapper added a comment.EditedNov 25 2016, 12:07 PM

...and it's also been discussed in depth why enabling voting often does not make any sense. :)